package unot;

import java.io.*;
import java.util.*;

/**
 * ϥեؤΥΡɽ񤭽Ф롼Υ饹Υƥץ졼ȡ 
 */
class ChildFormatLineWriter extends LineWriter {

	public static final String signature = "child";
	static final String writerName = signature+" "+"ChildFormatLineWriter for DocSet";
	public String getName() { return writerName; }

	public ChildFormatLineWriter(DocSet docset, PrintStream out) {
		super(docset, out);
	}

	/**
	 * Ρɤ򣱹Ԥ˽񤭽Ф
	 *
	 * @exception IOException if an error occurs
	 */
	public void writeNodeLine(UnotNode node) throws IOException
	{
		if (node == null)
			throw new IOException();
		//out.println(node);
		out.print(node.getNodeId());
		out.print(" "+docset.getLabelString(node));
		NodeList children = node.getChildren();
		for (int i = 0; i < children.size(); i++) {
			UnotNode child = (UnotNode) children.get(i);
			out.print(" "+child.getNodeId());
		}
		out.println();
	}	

} // ChildFormatLineWriter

//EOF 

