package unot;

import java.io.*;
import java.util.*;

/**
 * ϥեιɤ߹ߥ롼Υ饹Υƥץ졼ȡ
 * ϡ̤γեǹԤ
 */
abstract class LineReader {

	public static final boolean DEBUG_READLINE = false;

	/** StreamTokenizerʬ饹ˤ٤ */
	private static int TT_DOUBLE_QUOTE = '\"';
	private static int TT_SINGLE_QUOTE = '\'';

	abstract String getSignature();

	/** 饹⤫黲Ȥȡʥ */
	public StreamTokenizer st;
	public DocSet docset;
		
	public LineReader(DocSet docset, StreamTokenizer st) {
		this.st = st;
		this.docset = docset;
	}

	abstract UnotNode readNodeLine() throws IOException; 

	// Utilities 

	void skipRestOfLine() throws IOException {
		//ԤλĤɤФ
		while ((st.nextToken() != StreamTokenizer.TT_EOL)
			   && (st.ttype != StreamTokenizer.TT_EOF))
			; //skip
	}

	int readNumberLine() throws IOException {
		int number; 
		if (st.ttype == StreamTokenizer.TT_NUMBER) {
			number = (int) st.nval;
		} else {
			throw new IOException("a number expected"+
								"["+st.sval+"]");
		}
		this.skipRestOfLine(); //ԤλĤɤФ
		return number;
	}

	String readWordLine() throws IOException {
		String word; 
		if (st.ttype == StreamTokenizer.TT_WORD) {
			word = new String(st.sval);
		} else {
			throw new IOException("a word expected"+
								"["+st.sval+"]");
		}
		this.skipRestOfLine(); //ԤλĤɤФ
		return word;
	}

	IndexList readIndexList() throws IOException {
		IndexList list = new IndexList();
		while (st.ttype != StreamTokenizer.TT_EOL) {
			if (st.ttype == StreamTokenizer.TT_NUMBER) {
				int number = (int) st.nval;
				list.add(number);
			} else {
				throw new IOException("a number expected"+
									  "["+st.sval+"]");
			}
			st.nextToken();
		}
		return list;
	}

	/** Utility  */
	String tokenTypeName(StreamTokenizer st) {
		String str = null;
		if (st.ttype == StreamTokenizer.TT_EOF) {
			str = "TT_EOF";
		}
		else if (st.ttype == StreamTokenizer.TT_EOL) {
			str = "TT_EOL";
		}
		else if (st.ttype == StreamTokenizer.TT_NUMBER) {
			str = "TT_NUMBER";
		}
		else if (st.ttype == StreamTokenizer.TT_WORD) {
			str = "TT_WORD";
		}
		else if (st.ttype == LineReader.TT_DOUBLE_QUOTE) {
			str = "TT_DOUBLE_QUOTE";
		}
		else if (st.ttype == LineReader.TT_SINGLE_QUOTE) {
			str = "TT_SINGLE_QUOTE";
		}
		else if (0 <= st.ttype && st.ttype < 128) {
			str = "LETTER("+String.valueOf((char)st.ttype)+")";
		}
		else {
			str = "UNKNOWN("+st.ttype+")";
		}
		return str;
	}

} // LineReader


//LineWriter

